<?php

require ("vglib.php");

CheckCookie();

require ("vglinklib.php");
require ("lib-editsong.php");
require ("taglib.php");

session_start();

$prevformname="editsongform";


//Here are a lot (though not all) of the post variables we need to grab from the previous form.
	$varstoget_fromform=array("title", "filename", "localfolder", "url", "urltype", "hours", "mins", "secs", "label1", "label2", "label3", "sublabels", "genre", "vocals", "words", "malevocals", "femvocals", "foreignlang", "profanity", "volumewarning", "grating", "disturbing", "humorous", "nonewlabel", "warning", "comment", "privatenote", "temphide", "addlater", "findagain", "medley", "deleted", "filesize", "filetype", "adjectivestring", "genrestring", "leadinstrumentstring", "otherinstrumentstring", "otherstring", "languagestring");


//"me", "ve", "ma", "ju", "sa", "ur", "ne", "pl", "er" - plarating text boxes.
//plaboxes = the planet checkboxes.

//"sourcestring", "performerstring", "vocaliststring", "remixerstring", "composerstring"


$song_id=$_POST[song_id];	//If the previous page was an
	//Edit page, then, the ID will be here (delivered by a hidden
	//field on the last page).


//We want to keep "raw" copies of the following variables, obtained prior to running the CleanInput function on $_POST,
	//since it's easier to compare the raw, non-escaped copies to the "prev" versions of those variables to ascertain 
	//whether the new data is different from the old data or not.
	
	$raw_varstomake=array("adjectivestring", "genrestring", "leadinstrumentstring", "otherinstrumentstring", "otherstring", "languagestring", "localfolder", "filename");

	foreach ($raw_varstomake as $current_var)
	{	
		$rawvarname="raw_$current_var";
		${$rawvarname}=$_POST[$current_var];
	}
	
if ($song_id==0)
{	$action="Add";		//This means we're adding a new song, and can avoid doing certain things
						//that are necessary if we're editing an existing song.
}
else
{	$action="Edit"; //This means we're editing a song already in the database.  So, this means we have to figure out
						//whether or not some of the data the user input is different from the original data.

	//Prev vars are only present if we're editing a previous song.  So, we retrieve them here.
	//These make it possible to tell (without querying the DB) if a namestring or tagstring was changed.
	$prev_varstomake=array("adjectivestring", "genrestring", "leadinstrumentstring", "otherinstrumentstring", "otherstring", "languagestring", "sourcestring", "performerstring", "vocaliststring", "remixerstring", "composerstring");

	foreach ($prev_varstomake as $current_var)
	{	$prevvarname=substr($current_var, 0, -5); //Getting rid of "tring" at the end.
		$prevvarname="prev$prevvarname";
		${$prevvarname}=$_POST[$prevvarname];
		$_SESSION[$prevvarname]=$_POST[$prevvarname];
		${$prevvarname}=ereg_replace("&quot;", "\"", ${$prevvarname});
	}
	
	//Onward.  Most of the tag stuff is handled at the end, but some is in the middle.
}


//This makes it so the forms will be conveniently filled out
//with the user's previous input if an error requires us to
//send the user back to the form.  It also makes it possible
//for the user to edit any song with details from a previous
//session preloaded.

	$numofvarstoget_fromform=count($varstoget_fromform);
	$x=0;
	while ($x<$numofvarstoget_fromform)
	{	$varname=$varstoget_fromform[$x];
		$_SESSION[$varname]=$_POST[$varname];
		$x++;
	}


$_SESSION[sources]=$_POST[sources];
$_SESSION[performers]=$_POST[performers];
$_SESSION[vocalists]=$_POST[vocalists];
$_SESSION[remixers]=$_POST[remixers];
$_SESSION[composers]=$_POST[composers];


//OK, now we grab the planet checkboxes.

$planetboxes=$_POST['plaboxes'];

//print_r($planetboxes);

if (is_array($planetboxes))
{	//Even if only one planet checkbox is checked, this becomes an array.
	//Thank goodness.  Makes my life easier.
	
	//OK, what this does is, it makes an array in this format:
	//Array ( [1] => present [2] => present ) 
	//The above is the result of the Mercury and Venus checkboxes being checked.
	
	$x=0;
	foreach ($planetboxes as $pla)
	{	$plakeys[$x]=$pla;
		$x++;
	}
	$plarray = array_fill_keys($plakeys,'present');
}


//And then we grab the planet ratings, which the user can type into the boxes below the checkboxes.

$plabbrev=array("me", "ve", "ma", "ju", "sa", "ur", "ne", "pl", "er");

	$numofplabbrevs=count($plabbrev);
	
	foreach ($plabbrev as $plabbrevname)
	{	${$plabbrevname}=$_POST[$plabbrevname];
		$_SESSION[$plabbrevname]=${$plabbrevname};
	}

	//And make an array out of them.

$plaratings=array(0,$me,$ve,$ma,$ju,$sa,$ur,$ne,$pl,$er);

	//The user might have typed in a lowercase x, in which case we want it uppercase.

array_walk($plaratings,uppercase);


//OK, now this zips through the ratings and checkboxes and
//prepares the ratings' values for input into the database.
//
//If a rating is X (which means, definitely not presentt), 
//its equivalent in the database will be -9.
//
//If a rating is blank but that planet's checkbox is checked,
//its equivalent in the database will be not 0, but -8.
//
//Any ratings greater than 4 will be changed to 4.  Any
//ratings less than 0 and not less than -7 will be made
//positive, and if they turn out to be greater than 4,
//they will be changed to 4.

for ($x=1;$x<10;$x++)
{	$checkbox = $plarray[$x];
	$rating=$plaratings[$x];

	if ($checkbox=='')	//If the checkbox wasn't checked then $checkbox will be empty.
	{	if ($rating=="X" || $rating=="x")	//All we have to do now is figure out if there should be an X in the
		{	$rating=-9;		//rating box, or nothing.
		}
		else
		{	$rating=0;
		}
	}
	else if ($checkbox)
	{	if ($rating=="X" || $rating=="x")
		{	$rating=-9;
		}
		else if ($rating=="0" || $rating=='')
		{	$rating=-8;
		}

		if ( ($rating < 0) && !($rating<-7) )
		{	$rating=abs($rating);
		}
		if ($rating>4)
		{
			$rating = 4;
		}
	}
	$plaratings[$x]=$rating;
//	if ($rating==0)
//	{	unset($plaratings[$x]);
//	}
}

$_SESSION[plaratings]=$plaratings;


	$x=0;
	while ($x<$numofplabbrevs)
	{	$plabbrevname=$plabbrev[$x];
		${$plabbrevname}=$plaratings[$x+1];
		$x++;
	}

	

 //Now, we check for required fields from the form.  If any aren't there,
    //then, we send the user back to the forms page and show a
    //helpful error message, along with the forms being 
    //conveniently filled out with the user's previous input.

/* Originally, the user had to input more data for their form submission to be processed, but I
changed my mind.  if ( (!$_POST[title]) || (!$_POST[sources]) || ( (!$_POST[label1]) && (!$_POST[label2]) && (!$_POST[label3]) ) ) 

Now, only a source name is needed. */

if ( (!$_POST[sources]) )
{
	$_SESSION[error]="blank forms";
	GoBackToForm();
}

	//INow, we connect to the database.

$handle=ConnectToDb();

array_walk($_POST,'CleanInput');  
	//Puts \ behind the quotes and stuff like that to make the
	//input safe for the MySQL DB.


//Just resetting this in case the original, uncleaned input wasn't safe:
$song_id=$_POST['song_id'];

//Gets the variables from the form.
	$x=0;
	while ($x<$numofvarstoget_fromform)
	{	$varname=$varstoget_fromform[$x];
		${$varname}=$_POST[$varname];
		$x++;
	}
	$varstoget_fromform=array_merge($varstoget_fromform, $plabbrev);
	
	
	$tagstring_vars=array("adjectivestring", "genrestring", "leadinstrumentstring", "otherinstrumentstring", "otherstring", "languagestring");

$changed_tagtypes=array();

	//Then we figure out if the new raw tagstring variables are different from the previous tagstring variables,
	//and clean up any changed tagstrings.
	
	foreach ($tagstring_vars as $tagstringvar)
	{
		$rawtagstringvar="raw_$tagstringvar";
		if ($action=="Edit")
		{	$prevtagstringvar="prev$tagstringvar";
			$prevtagstringvar=substr($prevtagstringvar, 0, -5); //Getting rid of "tring" at the end.
		}
		$thistagtype=substr($tagstringvar, 0, -6); //Gets rid of "string" at the end.

		if ( ($action=="Edit" && ${$rawtagstringvar} != ${$prevtagstringvar} ) || ($action=="Add" && ${$rawtagstringvar} ) )
		{
				$tags_changed="true";
			${$tagstringvar}=CleanUpTagstring( ${$rawtagstringvar} );
		
			$quotelessvar="quoteless_" . $tagstringvar;		//Later on, the tagstring vars are going to end up
			${$quotelessvar}=${$tagstringvar};		//surrounded by quotes for input into the songinfo table, so we
												//want to preserve a nice, untouched copy of the cleaned-up
											//tagstrings without quotes for when we input the tags into the tags DB.
			array_push($changed_tagtypes, $thistagtype);
		}
	}

	
$sources=$_POST[sources];
$performers=$_POST[performers];
$vocalists=$_POST[vocalists];
$remixers=$_POST[remixers];
$composers=$_POST[composers];


//	echo "Me: $me  Ve: $ve  Ma: $ma er: $er";


//OK, now we need to retrieve some stuff from the database, based
//on the user's input.  Namely, we have to get the entity ids
//and spelling ids for the names the user input.

//That is, if the user input any names.

if ($sources || $performers || $vocalists || $remixers || $composers)
{
	$types = array("source", "performer", "vocalist", "remixer", "composer");

	$num_of_types=count($types);


		//We begin constructing a query.
	$query_to_issue="SELECT name, abbrev, entity_id, spelling_id FROM vgNames WHERE name in (";

	$allnames=array();


	//Oh no, it's time for some "variable variables".
	$x=0;

	while ($x<$num_of_types)
	{	$type=$types[$x] . "s";
		$list_of_namevars[$x]=$type;

		${$type}=$_POST[$type];

		$typearray="array" . $type;

		$list_of_namearrays[$x]=$typearray;

		${$typearray} = MakeStringIntoArray( ${$type}, "split at commas");

		${$typearray} = array_values( ${$typearray} );

		$allnames = array_merge($allnames, ${$typearray});

		$formattypename="formatted" . $type;	//Example: "formattedsources".
		$list_of_formatnamearrays[$x]=$formattypename;

		${$formattypename} = MakeArrayIntoFormattedNameString( ${$typearray}, 1);

		if (${$formattypename})
		{	$query_to_issue .= ${$formattypename} . ", ";
		}
		$x++;
	}

	$query_to_issue=rtrim($query_to_issue, ", ");
	$query_to_issue .= ") OR abbrev in (";
	$x=0;

	while ($x<$num_of_types)
	{	$type=$types[$x] . "s";
		$formattypename="formatted" . $type;
		if (${$formattypename})
		{
			$query_to_issue .= ${$formattypename} . ", ";
		}
		$x++;
	}

	$query_to_issue=rtrim($query_to_issue, ", ");

	$query_to_issue .= ")";

	$allnames=array_iunique($allnames);
	$allnames=array_values($allnames);

	$num_of_allnames=count($allnames);


		//Finally, we get to issue the query.

	//	echo $query_to_issue;
		
	$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


		//If there are fewer rows than there are entries in the array,
		//that means there are some entries in the array which aren't
		//yet in the database.  So, we send the user back to the form
		//with an error.
		
		//It's too troublesome to figure out which names exactly are missing, 
		//so the user will have to figure that out theirself.

	if (mysql_num_rows($query_result) < $num_of_allnames)
	{
		$_SESSION[error]="nonexistent name";
		GoBackToForm();
	}


	while ( $row = mysql_fetch_array($query_result) )
	{	$name=strtolower($row[name]);
		$name=mysql_real_escape_string($name);

		$abbrev=strtolower($row[abbrev]);
		$abbrev=mysql_real_escape_string($abbrev);

		$spellingid=$row[spelling_id];
		$entityid=$row[entity_id];

		$array_namespellingids[$name]=array($spellingid, $entityid);
		$array_namespellingids[$abbrev]=array($spellingid, $entityid);
	}
}


//Whew, that wasn't too hard.  OK, now we make sure the file path URL
//is ready, simply so we can get the filetype and filesize.

$fixedlocalfolder=BackToForwardSlashes($raw_localfolder);
$fixedlocalfolder=ConvertFirefoxFormat($fixedlocalfolder);
$fixedlocalfolder=ConvertSpacesTo20($fixedlocalfolder);
$completelocalurl=$fixedlocalfolder . "/" . $raw_filename;

$pathparts=pathinfo($completelocalurl);

$filetype=$pathparts['extension'];
$_SESSION[filetype]=$filetype;

$plainpath=explode("file://localhost/",$completelocalurl);

$thisphppath = $plainpath[1];
$thisphppath = Convert20ToSpaces($thisphppath);

if (is_file($thisphppath) )
{	//echo "IT'S A FILE!!!";
	$filesize=filesize($thisphppath);
}


	
//OK, now with all that out of the way, we move on to 
//translating the labels into their numerical equivalents.

$label1 = PlaToNum( strtolower($label1) );
$label2 = PlaToNum( strtolower($label2) );
$label3 = PlaToNum( strtolower($label3) );

if ($hours>255)
{	$hours=255;
}
if ($mins>59)
{	$mins=59;
}
if ($secs>59)
{	$secs=59;
}

$checkboxes = array(&$vocals, &$words, &$malevocals, &$femvocals, &$foreignlang, &$profanity, &$volumewarning, &$grating, &$disturbing, &$humorous, &$nonewlabel, &$temphide, &$addlater, &$findagain, &$medley, &$deleted);

$numberboxes = array(&$me, &$ve, &$ma, &$ju, &$sa, &$ur, &$ne, &$pl, &$er, &$hours, &$mins, &$secs, &$label1, &$label2, &$label3);

FixCheckboxValues();
FixNumberboxValues();

//echo "Er: $er";


function FixCheckboxValues()
{	global $checkboxes;

	$x=0;
	$len=count($checkboxes);
	while ($x<$len)
	{	$thisbox=$checkboxes[$x];

		if ($thisbox!="y")
		{	$checkboxes[$x]="n";
		}
		$x++;
	}
}

function FixNumberboxValues()
{	global $numberboxes;
	$x=0;
	$len=count($numberboxes);
	while ($x<$len)
	{	$thisbox=$numberboxes[$x];
		//echo "Thisbox: $thisbox";

		if (!is_numeric($thisbox) || $thisbox===false)
		{	//$numberboxes[$x]="NULL";
			unset($numberboxes[$x]);
		}
		$x++;
	}
}

function EncloseOrNull($value, $enclosure)
{	if (!empty($value) && $value!="NULL" && !is_numeric($value) )
	{
		//$reverse_enclosure=strrev($enclosure);
		$value = $enclosure . $value . $enclosure;
	}
	else if (is_numeric($value))
	{	//Then we leave the value as is.
	}
	else $value="NULL";

	return $value;
}



function TrimComma(&$value)
{	$value=substr ($value, 0, -2);
}

function MakeQueryParts()
{	global $varstoget_fromform, $prevformname, $allqueryparts, $song_id;

	$x=0;
	$numofvarstoget_fromform=count($varstoget_fromform);

	$querypartstring="querypart_";

	while ($x<$numofvarstoget_fromform)
	{	$varname=$varstoget_fromform[$x];
		global ${$varname};

		$sessionvarname=$prevformname . "_orig_" . "$song_id" . "_" . $varname;

		CleanInput($_SESSION[$sessionvarname]);

		if ($_SESSION[$sessionvarname]!=${$varname} )
		{	
			$queryvarname=$querypartstring . $varname;

			${$queryvarname}="$varname =";

			$enclosedval=EncloseOrNull(${$varname}, "'");

			${$queryvarname} .= "$enclosedval, ";

			$allqueryparts .= ${$queryvarname};
		}
		$x++;
	}
}

	/*$numofchangedtagtypes=count($changed_tagtypes);
	$x=0;
	while ($x<$numofchangedtagtypes)
	{	$varname=$changed_tagtypes[$x];
		$quotelessvarname="quoteless_" . $varname . "tagstring";
		$rawvarname="raw_" . $varname . "tagstring";
				
		${$quotelessvarname}=${$rawvarname};
		$x++;
	}*/



//print_r($varstoget_fromform);

if ($action=="Edit")
{
	MakeQueryParts();
	TrimComma($allqueryparts);
}
else
{	EncloseOrNullAll();
}

function EncloseOrNullAll()
{	global $varstoget_fromform;
	
	foreach ($varstoget_fromform as $varname)
	{	
		global ${$varname};
		$enclosedvarname="enclosed" . $varname;
		global ${$enclosedvarname};

		${$enclosedvarname}=EncloseOrNull(${$varname}, "'");
	}
}

function GetNowTimestamp()
{	$res=time();
	$res = date("Y-m-d H:i:s", $res);
	return $res;
}

$nowtimestamp=GetNowTimestamp();

$nowtimestamp .= " GMT";


//Now we print the page so it doesn't turn into a hideous blank white page with
//an error on it if the query failed.

echo "<html><head><title>Song $addedsong_id $action";

echo "ed</title>
<link rel=stylesheet href='css/a.css' type='text/css'>
</head>
<body><center>";

ListNav();

echo "<h1>Song $addedsong_id $action"; echo "ed</h1>
<p>
<big><a href='listsongs.php'>Song List</a></big><p>";

$x=0;
foreach ($varstoget_fromform as $var)
{	
	$ucvar=ucwords($var);
	echo "<b>$ucvar:</b> ${$var} &nbsp;&nbsp;";
	if ($x%5==0)
	{	echo "<br>";
	}
	$x++;
}

echo "<p><br>";
//Query issued: $query_to_issue
//<p>


	$sqlvarstoget=implode(", ", $varstoget_fromform);

function MakeSQLInsertVals()
{	global $varstoget_fromform, $sqlvals;
	$x=0;
	$numofvarstoget_fromform=count($varstoget_fromform);

	while ($x<$numofvarstoget_fromform)
	{	$varname=$varstoget_fromform[$x];
		global ${$varname};

		$enclosedvarname="enclosed" . $varname;

		global ${$enclosedvarname};

		$sqlvals .= "${$enclosedvarname}, ";
		$x++;
	}
	TrimComma($sqlvals);
}


MakeSQLInsertVals();

if ($action=="Add")
{	$query_to_issue = "INSERT INTO vgSongDetails ($sqlvarstoget, whenadded, whenmodified)";

	$query_to_issue .= " VALUES ($sqlvals, '$nowtimestamp', '$nowtimestamp')";

}

if ($action=="Edit")
{//whenmodified='$nowtimestamp'
	$query_to_issue="UPDATE vgSongDetails SET whenmodified='$nowtimestamp' ";
	if ($allqueryparts)
	{	$query_to_issue .= ", $allqueryparts";
	}

	$query_to_issue .= " WHERE song_id=$song_id";

}
//Must handle whenadded/whenmodified stuff somehow...


echo "<p>Query: $query_to_issue";

//Now we have everything we need to deposit the song
//into the vgSongDetails table.

//Then we issue the query.
mysql_query($query_to_issue,$handle) or die(mysql_error());



//And grab the ID of what was added.  This works correctly for
//REPLACEs as well as INSERTs, by the way.
$addedsong_id = mysql_insert_id();

echo "<p>";
echo "Added ID: $addedsong_id<p>";


//Now, if we're editing an existing song, we wipe out some previous 
//name associations with this song so we can add them anew.  We
//try to only wipe out name associations that have changed.

//if ($sources || $performers || $vocalists || $remixers || $composers)
//{
$x=0;

$query_to_issue = "INSERT INTO vgRolesAndSongs (spelling_id, entity_id, song_id, role) VALUES ";

if ($action=="Edit")
{
	$delete_query_to_issue = "DELETE FROM VgRolesAndSongs WHERE (song_id = '$song_id' AND (";

	while ($x<$num_of_types)
	{	$rolename=$types[$x];
		$type=$types[$x] . "s";
		$prevtype = "prev" . $type;
		${$prevtype} = $_POST[$prevtype];

		if ( ${$type} != ${$prevtype})
		{	$issuedeletequery="yes";
			$typearray = "array" . $type;
			$prevtypearray = "array" . $prevtype;
			${$prevtypearray} = MakeStringIntoArray( ${$prevtype}, "split at commas");
			${$prevtypearray} = array_values( ${$prevtypearray} );
			$delete_query_to_issue .= " role='$rolename' OR ";

			$num_of_names_of_this_type = count( ${$typearray} );
			if ($num_of_names_of_this_type)
			{	$y=0;
				$issuemainquery="yes";
				while ($y<$num_of_names_of_this_type)
				{	$thisname=strtolower( ${$typearray}[$y] );
					$thisspellingid = $array_namespellingids[$thisname][0];
					$thisentityid = $array_namespellingids[$thisname][1];

					$query_to_issue .= "('$thisspellingid', '$thisentityid', '$song_id', '$rolename'), ";
					$y++;
				}
			}
			else if (!$num_of_names_of_this_type)
			{	$issuemainquery="no";
			}

		};
		$x++;
	}	
	if ($issuedeletequery=="yes")
	{
			$delete_query_to_issue = substr($delete_query_to_issue, 0, -4);
			$delete_query_to_issue .= ") )";
			echo "<p>Delete query: $delete_query_to_issue";
			mysql_query($delete_query_to_issue,$handle) or die(mysql_error());
	}
	if ($issuemainquery=="yes")
	{
		$query_to_issue=substr($query_to_issue, 0, -2);
		echo "<p>Roles query: $query_to_issue<p>";
		mysql_query($query_to_issue,$handle) or die(mysql_error());
	}

}
else if ($action=="Add") //if we're just adding a new song
{
	$x=0;
	while ($x<$num_of_types)
	{	$rolename=$types[$x];
		$type=$types[$x] . "s";

		$typearray = "array" . $type;
		$num_of_names_of_this_type = count( ${$typearray} );
	
		$lowercasearray=${$typearray};

		array_walk($lowercasearray, 'lowercase');

		if ($num_of_names_of_this_type)
		{	$y=0;
			while ($y<$num_of_names_of_this_type)
			{	$thisname=strtolower( ${$typearray}[$y] );
				$thisspellingid = $array_namespellingids[$thisname][0];
				$thisentityid = $array_namespellingids[$thisname][1];

				$query_to_issue .= "('$thisspellingid', '$thisentityid', '$addedsong_id', '$rolename'), ";
				$y++;
			}
		}
		$x++;
	}
	$query_to_issue=substr ($query_to_issue, 0, -2);
	echo "<p>Roles query: $query_to_issue<p><br>";
	mysql_query($query_to_issue,$handle) or die(mysql_error());
	echo "<p><br>";
}

//Now we get rid of some no longer needed session variables set up by the previous form.
foreach ($varstoget_fromform as $varname)
{
	$sessionvarname=$prevformname . "_orig_" . "$song_id" . "_" . $varname;
	unset($_SESSION[$sessionvarname]);
	$x++;
}

//And finally, we handle the tag stuff.  It's a lot more complicated than what you see here -
//see taglib.php.

if ($tags_changed)
{	if ($action=="Add")
	{	$song_id=$addedsong_id;
		echo "Song ID: $song_id";
	}
	ManageTags("song", $song_id);
}

?>